#include "StdAfx.h"
#include "DuiTrayPopup.h"
#include "NeMessengerDlg.h"
#include "../../DuiLib/ucslib.h"

#define MARGIN_BETWEEN_POPS  (5)

DUI_BEGIN_CUSTOM_MSG_MAP(CDuiTrayPopup)
ON_CUSTOM_MSG(WM_USERIMAGE_UPDATED, _OnMsgUserImageUpdated)
DUI_END_CUSTOM_MSG_MAP()

#define TIMER_TOPMOST_ID  (1)
#define TIMER_TOPMOST_EPLISE (200)

CDuiTrayPopup::CWndTrayPopupMgr::CWndTrayPopupMgr()
{
}

CDuiTrayPopup::CWndTrayPopupMgr::~CWndTrayPopupMgr()
{
	KillAllTrayPopup();
}

void CDuiTrayPopup::CWndTrayPopupMgr::AddTrayPopup(CDuiTrayPopup * pTrayPopup)
{
	if(pTrayPopup){
		lstTrayPopup.AddTail(pTrayPopup);
	}
}

void CDuiTrayPopup::CWndTrayPopupMgr::KillAllTrayPopup()
{
	POSITION pos = lstTrayPopup.GetHeadPosition();
	while(pos)
	{
		CDuiTrayPopup * pTrayPopup = (CDuiTrayPopup*)lstTrayPopup.GetAt(pos);
		if(pTrayPopup)
        {
            pTrayPopup->Close(IDCANCEL);
			//delete pTrayPopup;
        }
		lstTrayPopup.GetNext(pos);
	}

	lstTrayPopup.RemoveAll();
}
void CDuiTrayPopup::CWndTrayPopupMgr::KillAllIPTTrayPopup()
{
	POSITION pos = lstTrayPopup.GetHeadPosition();
	while(pos)
	{
		CDuiTrayPopup * pTrayPopup = (CDuiTrayPopup*)lstTrayPopup.GetAt(pos);
		if(pTrayPopup && pTrayPopup->m_bIPT)
        {
            pTrayPopup->Close(IDCANCEL);
			//delete pTrayPopup;
        }
		lstTrayPopup.GetNext(pos);
	}

	lstTrayPopup.RemoveAll();
}


void CDuiTrayPopup::CWndTrayPopupMgr::KillTrayPopup(PVOID pData)
{
	if(pData)
	{
		POSITION pos = lstTrayPopup.Find(pData);

		if (NULL != pos) {		
			CDuiTrayPopup * pTrayPopup = (CDuiTrayPopup*)lstTrayPopup.GetAt(pos);
		    lstTrayPopup.RemoveAt(pos);
		}
	}
}

void CDuiTrayPopup::CWndTrayPopupMgr::HandleDeleteTrayPopup(CDuiTrayPopup* pTrayPopup)
{
	if(pTrayPopup)
	{
		POSITION pos = lstTrayPopup.Find(pTrayPopup);
		if(pos)
		{
			lstTrayPopup.RemoveAt(pos);			
			//delete pTrayPopup;
		}
	}
}

int CDuiTrayPopup::CWndTrayPopupMgr::GetTotalHeightByIndex( int index )
{
    ASSERT(index > -1);
	if (index >= lstTrayPopup.GetSize() || index == -1)
	{
		index = lstTrayPopup.GetSize() -1;
		// ASSERT(index > -1);
	}
	int i = 0;
	int totalHeight = 0;
	POSITION pos = lstTrayPopup.GetHeadPosition();
	if (!pos)
	{
		//ASSERT(FALSE);
	}
	while(pos && (i <= index))
	{
		CDuiTrayPopup * pTrayPopup = (CDuiTrayPopup*)lstTrayPopup.GetAt(pos);
		if(pTrayPopup)
			totalHeight += pTrayPopup->m_nHeight + MARGIN_BETWEEN_POPS;
		lstTrayPopup.GetNext(pos);
        i++;
	}
    return totalHeight;
}



int CDuiTrayPopup::m_nIndexArray[10]={0};
CDuiTrayPopup::CWndTrayPopupMgr CDuiTrayPopup::m_wndTrayPopupMgr;



CControlUI* CDuiTrayPopup::CreateControl(LPCTSTR pstrClass)
{
	CUCDialogBuilder builder;
	CControlUI *pControl = builder.CreateControl(pstrClass);
	if (pControl)
	{
		return pControl;
	}

	pControl = __super::CreateControl(pstrClass);

	return pControl;

}





LPCTSTR CDuiTrayPopup::GetWindowClassName() const
{
	return _T("DuiTrayPopup");
}

void CDuiTrayPopup::OnFinalMessage(HWND hWnd)
{
	m_wndTrayPopupMgr.HandleDeleteTrayPopup(this);
	CUserImageActor::Instance()->UnRegisterObserver(this);
    delete this;	
}

DUI_BEGIN_MESSAGE_MAP(CDuiTrayPopup, WindowImplBase, FALSE)
 DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
 DUI_ON_MSGTYPE(DUI_MSGTYPE_TIMER, OnTimer) 
DUI_END_MESSAGE_MAP()




CDuiString CDuiTrayPopup::GetSkinFile()
{
	if (TDT_IPT_EMPLYEE_INFO == m_trayDrawType)
	{
        return _T("trayPopIPTWnd.xml");
	} 
	else
	{
		return _T("trayPopWnd.xml");
	}
	
}

CDuiString CDuiTrayPopup::GetSkinFolder()
{
	return _T("skin\\nTalkRes\\");
}



CDuiTrayPopup::CDuiTrayPopup(CWnd* ParentWnd){
    SetHasFocusCtrl(false);
	m_nWidth            = 0;
	m_nHeight           = 0;
	m_nAnimateHeight    = 0;
	m_nAnimateTop       = 0;
	m_nIndex            = -1;
	m_nNotifyMessage=0; 
	m_pData=NULL;
	m_pParentWindow=NULL;
	m_nShowTimeSec=0;
	m_trayDrawType = TDT_LOGIN;
}

CDuiTrayPopup::~CDuiTrayPopup()
{	
	if(m_nIndex >= 0 && m_nIndex < 10)
		m_nIndexArray[m_nIndex] = 0;
}

HWND CDuiTrayPopup::Create(HWND pParent)
{	
	CRect rcWnd(0, 0, 0, 0);
	return WindowImplBase::Create(pParent, _T("DuiTrayPopup"), WS_POPUP /*|WS_VISIBLE*/, WS_EX_NOACTIVATE , rcWnd);	
}

void CDuiTrayPopup::InitWindow(){

	for(int i=0 ; i<10 ; i++)
	{
		if(m_nIndexArray[i] == 0)
		{
			m_nIndexArray[i] = 1;
			m_nIndex = i;
			break;
		}
	}
	if (m_nIndex >=10)
	{
		m_nIndex = 0;
	}
	if(m_bIPT)
		m_nIndex = 0;
	

	//::SetWindowPos(GetHWND(),NULL,0,0, 0, 0, SWP_NOACTIVATE);
	//::ShowWindow(GetHWND(), SW_SHOWNOACTIVATE);

}


void CDuiTrayPopup::OnPrepare(TNotifyUI& msg)
{	
	CUserImageActor::Instance()->RegisterObserver(this);
	//SetTimer(TIMER_TOPMOST_ID, TIMER_TOPMOST_EPLISE);
	DoPrepare();
}

void CDuiTrayPopup::DoPrepare(){	
	SetProfileImage(m_trayInfo.strID);
	SetTimer(TIMER_AUTO_DESTROY, m_nShowTimeSec * 1000);
    if (TDT_IPT_EMPLYEE_INFO == m_trayDrawType)
	{
		CSize szAvail(198,20);
		CTextUI* m_pLabel = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("txt_name")));
		CString name = m_strName + _T("<x 6>") + LoadStringFromResource(IDS_STR_TRAYIPT_HAVECALL);
		m_pLabel->SetText(name);		
		CSize sz = m_pLabel->EstimateSize(szAvail);
		m_pLabel->SetFixedWidth(sz.cx > szAvail.cx ? szAvail.cx : sz.cx);
		m_pLabel->SetFixedHeight(sz.cy);

		m_pLabel = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("txt_tel")));
		CString ext = LoadStringFromResource(IDS_STR_TRAYIPT_EXT) + _T("<x 10>")  + m_strExt;
		m_pLabel->SetText(ext);	
		sz = m_pLabel->EstimateSize(szAvail);
		m_pLabel->SetFixedWidth(sz.cx > szAvail.cx ? szAvail.cx : sz.cx);
		m_pLabel->SetFixedHeight(sz.cy);	

		m_pLabel = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("txt_job")));
		CString job = LoadStringFromResource(IDS_STR_TRAYIPT_DUTY) + _T("<x 10>")  + m_strJob;
		m_pLabel->SetText(job);	
		sz = m_pLabel->EstimateSize(szAvail);
		m_pLabel->SetFixedWidth(sz.cx > szAvail.cx ? szAvail.cx : sz.cx);
		m_pLabel->SetFixedHeight(sz.cy);

		m_pLabel = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("txt_dept")));
		CString part = LoadStringFromResource(IDS_STR_TRAYIPT_PART) + _T("<x 10>")  + m_strPart;
		m_pLabel->SetText(part);	
		sz = m_pLabel->EstimateSize(szAvail);
		m_pLabel->SetFixedWidth(sz.cx > szAvail.cx ? szAvail.cx : sz.cx);
		m_pLabel->SetFixedHeight(sz.cy);

	}
	else if (TDT_IM_CHAT == m_trayDrawType)
	{
		CHorizontalLayoutUI* pProfileBoard = static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindControl(_T("profile_board")));
		if ( pProfileBoard !=NULL)
		{
			pProfileBoard->SetVisible(true);
		}


		CVerticalLayoutUI *pPopMsgBoard = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(_T("text_popmsg_board")));
		pPopMsgBoard->SetVisible(false);
		pPopMsgBoard = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(_T("text_msg_board")));
		pPopMsgBoard->SetVisible(true);

		CTextUI* m_pLabelName = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("text_msg1")));
		m_pLabelName->SetText(m_trayInfo.strNickName);


		CTextUI* m_pLabelMsg = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("text_msg2")));		
		m_pLabelMsg->SetText(m_trayInfo.strMsg);	

	}
	else{
       if (TDT_USEAGE == m_trayDrawType)
		 {
			 CHorizontalLayoutUI* pProfileBoard = static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindControl(_T("profile_board")));
             if (pProfileBoard)
             {
				  pProfileBoard->SetVisible(false);
             }          			
			
		 }      

		 CVerticalLayoutUI *pPopMsgBoard = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(_T("text_popmsg_board")));
		 pPopMsgBoard->SetVisible(true);
		 pPopMsgBoard = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(_T("text_msg_board")));
		 pPopMsgBoard->SetVisible(false);


		 CTextUI* m_pLabelName = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("text_popmsg1")));
		 m_pLabelName->SetText(m_strMessage);
		
		 m_pLabelName->SetLineInterval(6);
	}

}

void CDuiTrayPopup::Show(TRAYPOPUP_DRAW_TYPE drawType, CString strID, CString strTitle,  CString strMessage, int nShowTimeSec ,
						 CWnd * pParent, UINT nNotifyMessage, PVOID pData ){

	 CDuiTrayPopup* pTrayPopup = new CDuiTrayPopup(pParent);
	 if (NULL == pTrayPopup)
		 return;

	 strMessage.Replace(_T("&lt;"), _T("<"));
	 strMessage.Replace(_T("&gt;"), _T(">"));
	 strMessage.Replace(_T("&amp;"), _T("&"));
	 strMessage.Replace(_T("&quot;"), _T("\""));
	 strMessage.Replace(_T("&#39;"), _T("'"));

     pTrayPopup->m_trayInfo.strID = strID;
	 pTrayPopup->m_trayDrawType = drawType;
	 pTrayPopup->m_strMessage = strMessage;
	 pTrayPopup->m_nNotifyMessage = nNotifyMessage;
	 pTrayPopup->m_pData = pData;
	 pTrayPopup->m_nShowTimeSec = nShowTimeSec;
	 pTrayPopup->m_bIPT = FALSE;


	
	 pTrayPopup->m_nWidth =  270;
     pTrayPopup->m_nHeight =  109;
	 


	 if(pTrayPopup->Create(GetDesktopWindow()))
	 {	
		 m_wndTrayPopupMgr.AddTrayPopup(pTrayPopup);

         pTrayPopup->m_pParentWindow = pParent;
		 SetWindowText(pTrayPopup->GetHWND(),strTitle);
		 ::SetWindowPos(pTrayPopup->GetHWND(), HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		 CalculatePosAndShow(pTrayPopup);

		
	 }
	 else
	 {
		//  m_wndTrayPopupMgr.KillTrayPopup(pTrayPopup);
		 delete pTrayPopup;
	 }
}

void CDuiTrayPopup::CalculatePosAndShow(CDuiTrayPopup* pTrayPopup){

    CRect m_rcDesktopRect(0, 0, 0, 0);
	SystemParametersInfo(SPI_GETWORKAREA, 0, &m_rcDesktopRect, 0);
	CRect rcRect = m_rcDesktopRect;

	rcRect.left = rcRect.right - pTrayPopup->m_nWidth - 5 ;
	(pTrayPopup->m_nIndex >= 0) ? rcRect.top = rcRect.bottom - m_wndTrayPopupMgr.GetTotalHeightByIndex(pTrayPopup->m_nIndex) - 5: rcRect.top = rcRect.bottom - pTrayPopup->m_nHeight - 5;

	::SetWindowPos(pTrayPopup->GetHWND(),HWND_TOPMOST,rcRect.left,rcRect.top, pTrayPopup->m_nWidth, pTrayPopup->m_nHeight, SWP_NOACTIVATE);
	::ShowWindow(pTrayPopup->GetHWND(), SW_SHOWNOACTIVATE);


}


void CDuiTrayPopup::ChatShow(TRAYPOPUP_DRAW_TYPE drawType, CString strTitle, 
					  TRAYPOPINFO info,int nShowTimeSec,
					  CWnd * pParent, UINT nNotifyMessage, PVOID pData)
{
	 CDuiTrayPopup* pTrayPopup = new CDuiTrayPopup(pParent);
	if (NULL == pTrayPopup)
		return;

	pTrayPopup->m_trayDrawType = drawType;
	pTrayPopup->m_trayInfo = info;
	pTrayPopup->m_nNotifyMessage = nNotifyMessage;
	pTrayPopup->m_pData = pData;
	pTrayPopup->m_nShowTimeSec = nShowTimeSec;
	pTrayPopup->m_bIPT = FALSE;
    pTrayPopup->m_strMessage = info.strMsg;
   
	if(drawType==TDT_IM_CHAT || drawType == TDT_LOGIN)
	{
		pTrayPopup->m_nWidth =  270;
		pTrayPopup->m_nHeight =  109;
	}

	if(pTrayPopup->Create(GetDesktopWindow()))
	{

		SetWindowText(pTrayPopup->GetHWND(),strTitle);
		pTrayPopup->m_pParentWindow = pParent;
		m_wndTrayPopupMgr.AddTrayPopup(pTrayPopup);
        CalculatePosAndShow(pTrayPopup);
	
	}
	else
	{
		// m_wndTrayPopupMgr.KillTrayPopup(pTrayPopup);
		delete pTrayPopup;
	}
}

void CDuiTrayPopup::IPTShow( TRAYPOPUP_DRAW_TYPE drawType, CString strID, CString strName, CString strExt, CString strPosition, CString strJob, 
		CString strPart, int nShowTimeSec /*= 60*/, CWnd * pParent /*= NULL*/, UINT nNotifyMessage /*= 0*/, PVOID pData /*= NULL*/ )
{
	CDuiTrayPopup * pTrayPopup = new CDuiTrayPopup(pParent);
	if (NULL == pTrayPopup)
		return;


	pTrayPopup->m_trayDrawType = drawType;
	pTrayPopup->m_trayInfo.strID = strID;
	pTrayPopup->m_nNotifyMessage = nNotifyMessage;
	pTrayPopup->m_pData = pData;
	pTrayPopup->m_nShowTimeSec = nShowTimeSec;
	pTrayPopup->m_strName = strName;
	pTrayPopup->m_strExt = strExt;
	pTrayPopup->m_strPosition = strPosition;
	pTrayPopup->m_strJob = strJob;
	pTrayPopup->m_strPart = strPart;
	pTrayPopup->m_bIPT = TRUE;

	pTrayPopup->m_nWidth =  270;
	pTrayPopup->m_nHeight =  138;
	if(pTrayPopup->Create(GetDesktopWindow()))
	{

		CString strTitle;
		strTitle = strName;
		strTitle.AppendFormat(L"%s",LoadStringFromResource(IDS_STRING585));
		SetWindowText(pTrayPopup->GetHWND(),strTitle);
		pTrayPopup->m_pParentWindow = pParent;
		m_wndTrayPopupMgr.AddTrayPopup(pTrayPopup);

		CalculatePosAndShow(pTrayPopup);

	}
	else
	{
		//m_wndTrayPopupMgr.KillTrayPopup(pTrayPopup);
		delete pTrayPopup;
	}
}

void CDuiTrayPopup::Kill(PVOID pData)
{
	if(!pData)    
		return;

	m_wndTrayPopupMgr.KillTrayPopup(pData);
}

void CDuiTrayPopup::KillAll()
{
	m_wndTrayPopupMgr.KillAllTrayPopup();
}
void CDuiTrayPopup::KillAllIPT()
{
	m_wndTrayPopupMgr.KillAllIPTTrayPopup();
}

void CDuiTrayPopup::OnTimer(TNotifyUI& msg) 
{
	if(msg.wParam == TIMER_AUTO_DESTROY)
	{
		KillTimer(TIMER_AUTO_DESTROY);
		PostMessage(WM_CLOSE,0,0);
		//::DestroyWindow(m_hWnd);
	}
	/*else if(msg.wParam == TIMER_ANIMATE)
	{
		KillTimer(TIMER_ANIMATE);
		EnableWindow(GetHWND(),TRUE);		
		ShowWindow(GetHWND(),SW_SHOWNOACTIVATE);    //Animatewindow Ѱ ȭ鿡 ׳ 
	}*/

}


LRESULT CDuiTrayPopup::OnMouseMove(UINT msg, WPARAM wparam, LPARAM lparam, BOOL& bHandled)
{
	CPoint point(0, 0);
	point.x = GET_X_LPARAM(lparam);
	point.y = GET_Y_LPARAM(lparam);
	if(m_pParentWindow && m_nNotifyMessage)
	{
		static bool bReDrawOnce = false;
		if(PtInRect(m_rcText, point))
		{
			SetTimer(TIMER_AUTO_DESTROY, m_nShowTimeSec * 1000);   //콺 öö ڵ Ÿ̸Ӹ ʱȭѴ.

			bReDrawOnce = true;
		}
		else
		{

			if(bReDrawOnce)
			{
				bReDrawOnce = false;
			}
		}
	}
  return 0;
}
LRESULT CDuiTrayPopup::OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& bHandled)
{
	CPoint pt(0,0);
	pt.x = GET_X_LPARAM(lParam);
	pt.y = GET_Y_LPARAM(lParam);

	CControlUI* pbg = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("topBG")));
	if (pbg)
	{
		pbg->SetBkImage(_T("img_alarm_popup_bg_top_on.png"));
	}

	CButtonUI* pbtn= static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("closebtn")));
	if (pbtn)
	{
		pbtn->SetNormalImage(_T("btn_alarm_popup_x_on.png"));
	}

	PostMessage(WM_CLOSE,0,0);
	KillTimer(TIMER_AUTO_DESTROY);	
	CRect rcCloseBtn(0, 0, 0, 0);
	CButtonUI *pCloseBtn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("closebtn")));
	if (pCloseBtn)
	{
		rcCloseBtn =  pCloseBtn->GetPos();
	}

	if(m_pParentWindow && !PtInRect(&rcCloseBtn,pt))    
	{
		if (m_nNotifyMessage)
		{				
			m_pParentWindow->PostMessage(m_nNotifyMessage, (WPARAM)m_pData);

		}

	}

	return 0;
}

LRESULT CDuiTrayPopup::OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& bHandled)
{
	CPoint pt(0,0);
	pt.x = GET_X_LPARAM(lParam);
	pt.y = GET_Y_LPARAM(lParam);


    CRect rcCloseBtn(0, 0, 0, 0);
	 CButtonUI *pCloseBtn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("closebtn")));
	 if (pCloseBtn)
	 {
		   rcCloseBtn =  pCloseBtn->GetPos();
		   if(PtInRect(&rcCloseBtn,pt))    
		   {
			   CControlUI* pbg = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("topBG")));
			   if (pbg)
			   {
				   pbg->SetBkImage(_T("img_alarm_popup_bg_top_off.png"));
			   }

			   CButtonUI* pbtn= static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("closebtn")));
			   if (pbtn)
			   {
				   pbtn->SetNormalImage(_T("btn_alarm_popup_x_off.png"));
			   }
		   }
	 }

   return 0;
}

void CDuiTrayPopup::SetProfileImage(CString strUserId)
{	
	CButtonUI* pProfilePic = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("profile_pic")));
	if (pProfilePic != NULL)
	{

		CString strFileName = GET_APP()->GetProfileImagePath(strUserId);
		pProfilePic->SetBkImage(strFileName);

		if(!CUserImageActor::Instance()->IsUserImageExist(strUserId.GetBuffer()))
		{
			std::list<std::wstring> listUserIds;
			listUserIds.push_back(wstring(strUserId.GetBuffer()));
			CUserImageActor::Instance()->RequestUserImages(listUserIds);
		}
		
	}
}

void CDuiTrayPopup::UpdateProfileImage( CString strUserId )
{
	if(m_trayInfo.strID != strUserId)
	{
		return;
	}

	CButtonUI* pProfilePic = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("profile_pic")));
	if (pProfilePic != NULL)
	{
		CString strFileName = GET_APP()->GetProfileImagePath(strUserId);
		pProfilePic->SetBkImage(strFileName);
	}
}

void CDuiTrayPopup::OnUserImageActor_OnResponseUserImageInfo( CString strUserId )
{
	PostMessage(WM_USERIMAGE_UPDATED, (WPARAM)(new CString(strUserId)), 0);
}

LRESULT CDuiTrayPopup::_OnMsgUserImageUpdated( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	CString* pStr = NULL;
	pStr = (CString*)wParam;
	if(pStr != NULL)
	{
		UpdateProfileImage(*pStr);
		if(pStr != NULL)
		{
			delete pStr;
			pStr = NULL;
		}
	}
	return 0;
}
